/*
 * Copyright (C) 2001 by Peter Simons <simons@computer.org>.
 * All rights reserved.
 */

#include <iostream>
#include "RegExp.hh"

using namespace std;

int
main(int argc, char ** argv)
try {
    if (argc != 2)
	{
	cerr << "Usage: " << argv[0] << " regexp\n";
	return(1);
	}

    // Test the regular expression code.

    const RegExp exp(argv[1]);
    while(cin)
	{
	char line[256];
	cin.getline(line, sizeof(line));
	if (strlen(line) > 0)
	    {
	    if (exp == line)
		cout << line << " matches " << argv[1] << endl;
	    else
		cout << line << " does not match " << argv[1] << endl;
	    }
	}

    const RegExp  exp2("^([^ \t]+)[ \t]+(.*)$", REG_EXTENDED);
    vector<string> vec;
    if (exp2.submatch("ConfigFile\t\t \"data is here  \"\t ", vec))
	cout << vec[1] << " - " << vec[2] << endl;
    else
	cout <<  "An error occured." << endl;

    return 0;
    }
catch(exception& e)
    {
    cerr << "** An error occured: " << e.what() << endl;
    return 1;
    }
catch(...)
    {
    cerr << "FATAL ERROR: Caught unknown exception!" << endl;
    return 1;
    }
